package com.example.soulfood_assignment2;

import android.animation.ObjectAnimator;
import android.content.Intent;
import android.support.v4.view.ViewCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.EditText;
import android.widget.ProgressBar;

import com.spotify.android.appremote.api.ConnectionParams;
import com.spotify.android.appremote.api.Connector;
import com.spotify.android.appremote.api.SpotifyAppRemote;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

public class MainActivity extends AppCompatActivity {

    private int currentProgress = 0;
    private ProgressBar PBar;
    private int maxValue;
    private int progressValue;

    private static final String CLIENT_ID = "n";
    private static final String REDIRECT_URI = "HTTP"; // URI to application domain
    private SpotifyAppRemote mSpotifyAppRemote;

    int swipeStartX = -50; //arbitrary default value
    int swipeEndX;
    View sideView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_loading_screen);

        PBar = findViewById(R.id.progressBar);
        PBar.setMax(100);
        PBar.setProgress(0);

        Thread thread = new Thread() {
            public void run() {
                try {
                    for (int i = 0; i < 100; i++) {
                        PBar.setProgress(i);
                        sleep(30);
                    }

                } catch(Exception exception) {
                    exception.printStackTrace();

                } finally {
                    Intent intent = new Intent(getApplicationContext(), homeScreen.class);
                    startActivity(intent);
                    finish();

                }
            }

        };
        thread.start();

    }

    protected File doInBackground(Void...Voids) {

        String input = null;
        File test = new File(input);

        try{
            FileInputStream fileInput = new FileInputStream(test);
            BufferedInputStream stream = new BufferedInputStream(fileInput);
            ByteArrayOutputStream out = new ByteArrayOutputStream();

            int inputNum = stream.read();
            int ticker = 0;

            while(inputNum != -1){
                ticker++;

                if(ticker%100 == 0){
                    publishProgress(out.size());
                }

                out.write(inputNum);
                inputNum = stream.read();
            }

            FileOutputStream OutStream = new FileOutputStream(test);

        }
        catch(FileNotFoundException e){

        }
        catch(IOException e){

        }


        return null;
    }

    private void publishProgress(int size) {
        Thread thread = new Thread() {
            public void run() {
                try {
                    for (int i = 0; i < 100; i++) {
                        PBar.setProgress(i);
                        sleep(30);
                    }

                } catch(Exception exception) {
                    exception.printStackTrace();

                } finally {
                    Intent intent = new Intent(getApplicationContext(), homeScreen.class);
                    startActivity(intent);
                    finish();

                }
            }

        };
        thread.start();
    }
	
	    protected void onStart() {
        super.onStart();

        ConnectionParams connP =
                new ConnectionParams.Builder(CLIENT_ID)
                        .setRedirectUri(REDIRECT_URI)
                        .showAuthView(true)
                        .build();


        SpotifyAppRemote.connect(this, connP, new Connector.ConnectionListener() {

            public void onConnected(SpotifyAppRemote spotifyAppRemote) {
                mSpotifyAppRemote = spotifyAppRemote;
                Log.d("MainActivity", "Connected");

                connected();
            }

            public void onFailure(Throwable throwable) {
                Log.e("MainActivity", throwable.getMessage(), throwable);

                // Something went wrong when attempting to connect! Handle errors here
            }

        });
    }

    private void connected(){
        mSpotifyAppRemote.getPlayerApi().play("spotify:playlist:37i9dQZF1DX2sUQwD7tbmL");
    }

    protected void onStop() {
        super.onStop();
    }
}
